Schema: LocateFragment (ID: 1741)
One fragment per locate line: born from a StockLocateResponse (fragSource Vendor, fragID = requestID; the gateway's rolling requestID-0 response maps to one updating fragment) or an AwayStockLocate statement (fragSource Notice, fragID = noticeID). Published ONLY by execution engines, atomically with AvailableStockLocates under the pool lock. Short-sale fills allocate FIFO by grantTimestamp within (pool, lane); a release reduces locateQuan to the consumed floor, never below, and never deletes the fragment.
METADATA
| Attribute | Value |
|---|---|
| Topic | 1725-client-borrow |
| MLink Token | ClientControl |
| MLink Endpoint | MLink-Live |
| SRSE Product | SRControl |
Note: The symbol
=next to a field number indicates that it is a primary key.
BODY
| # | Field | Type | Default Value | Comment |
|---|---|---|---|---|
| 10= | ticker | TickerKey | ||
| 11= | coreClientFirm | string(16) | ||
| 12= | locateFirm | string(6) | ||
| 13= | locatePool | string(16) | locate pool @ firm granting the locate | |
| 14= | lane | enum : ProdTest | propagated from the input command/response | |
| 15= | tradeDate | DateKey | ||
| 16= | fragSource | enum : LocateFragSource | ||
| 17= | fragID | long | requestID (Vendor) or noticeID (Notice); 0 = the rolling line | |
| 100 | locateQuan | int | granted/stated quantity on this line (post consumed-floor reconcile) | |
| 103 | locateQuanUsed | int | shares sold short allocated to this line (FIFO) | |
| 106 | availableLocateQuan | int | locateQuan - locateQuanUsed | |
| 109 | locateStatus | enum : LocateStatus | ||
| 112 | grantTimestamp | DateTime | FIFO position; fixed at fragment creation | |
| 115 | engineName | string(32) | SR server code | |
| 118 | timestamp | DateTime | ||
| 121 | statedQuan | int | quantity the source last stated; locateQuan = max(statedQuan, min(locateQuanUsed, stmtFloor)) | |
| 124 | stmtFloor | int | consumption a downward statement could not undo | |
| 127 | stmtTimestamp | DateTime | source record timestamp; an older statement never overrides a newer one | |
| 130 | legacyStmt | enum : YesNo | Yes = stated via ClientStockLocate (1731); loses ties to AwayStockLocate | |
| 133 | stmtRevision | int | bumped by every accepted statement or delete; recovery restores only a higher revision |
Get Schema API Call
- Python
- cUrl
import requests
# Replace with your desired MLINK URL
MLINK_PROD_URL = 'https://mlink-live.nms.saturn.spiderrockconnect.com/rest/json'
# Replace with your MLINK API Key
API_KEY = 'XXXX-XXXX-XXXX-XXXX'
# Replace with your desired MsgType.
MSG_TYPE = 'LocateFragment'
# Request Parameters for Get Schema Of The MsgType
params = {
# Required Parameters
"apiKey": API_KEY,
"cmd": 'getschema',
"msgType": MSG_TYPE,
}
response = requests.get(MLINK_PROD_URL, params=params)
curl -G 'https://mlink-live.nms.saturn.spiderrockconnect.com/rest/json' \
--data-urlencode 'apiKey=XXXX-XXXX-XXXX-XXXX' \
--data-urlencode 'cmd=getschema' \
--data-urlencode 'msgType=LocateFragment'
Get Msg API Call
- Python
- cUrl
import requests
# Replace with your desired MLINK URL
MLINK_PROD_URL = 'https://mlink-live.nms.saturn.spiderrockconnect.com/rest/json'
# Replace with your MLINK API Key
API_KEY = 'XXXX-XXXX-XXXX-XXXX'
# Replace with your desired MsgType.
MSG_TYPE = 'LocateFragment'
# Replace with your pkey value for getting the specific message desired
PKEY = 'ReplaceThisValueForTheQueryToWork'
# Replace with your desired view. A "|" separated list of views can be provided
# If no view is provided, all views will be returned.
VIEW = 'locateQuan|locateQuanUsed|availableLocateQuan|locateStatus|grantTimestamp|engineName|timestamp|statedQuan|stmtFloor|stmtTimestamp|legacyStmt|stmtRevision'
# Replace with your desired where clause.
# a string in the form "field1:eq:valuse" or "(field1:ne:value1 & field1:ne:value2)
# "WHERE" clauses can contain the following comparison symbols:
# :gt: is greater than
# :ge: is greater than or equal to
# :lt: is less than
# :le: is less than or equal to
# :eq: is equal
# :ne: is not equal
# %26 is an AND statement
# | is an OR statement
# :sw: is starts with
# :ew: is ends with
# :cv: is contains values
# :nv: is does not contain value
# :cb: is contained between (two dates for instance) separated by '$'
WHERE = 'coreClientFirm:eq:ExampleString'
# Request Parameters for getmsg Of The MsgType
params = {
# Required Parameters
"apiKey": API_KEY,
"cmd": 'getmsg',
"pkey": PKEY,
"msgType": MSG_TYPE,
# Optional Parameters
"view": VIEW,
"where": WHERE
}
response = requests.get(MLINK_PROD_URL, params=params)
curl -G 'https://mlink-live.nms.saturn.spiderrockconnect.com/rest/json' \
--data-urlencode 'apiKey=XXXX-XXXX-XXXX-XXXX' \
--data-urlencode 'cmd=getmsg' \
--data-urlencode 'pkey=ReplaceThisValueForTheQueryToWork' \
--data-urlencode 'msgType=LocateFragment' \
--data-urlencode 'view=locateQuan|locateQuanUsed|availableLocateQuan|locateStatus|grantTimestamp|engineName|timestamp|statedQuan|stmtFloor|stmtTimestamp|legacyStmt|stmtRevision' \
--data-urlencode 'where=coreClientFirm:eq:ExampleString'
Get Msgs API Call
- Python
- cUrl
import requests
# Replace with your desired MLINK URL
MLINK_PROD_URL = 'https://mlink-live.nms.saturn.spiderrockconnect.com/rest/json'
# Replace with your MLINK API Key
API_KEY = 'XXXX-XXXX-XXXX-XXXX'
# Replace with your desired MsgType.
MSG_TYPE = 'LocateFragment'
# Replace with your desired view. A "|" separated list of views can be provided
# If no view is provided, all views will be returned
VIEW = 'locateQuan|locateQuanUsed|availableLocateQuan|locateStatus|grantTimestamp|engineName|timestamp|statedQuan|stmtFloor|stmtTimestamp|legacyStmt|stmtRevision'
# Replace with your desired where clause.
# a string in the form "field1:eq:value" or "(field1:ne:value1 & field1:ne:value2)
# "WHERE" clauses can contain the following comparison symbols:
# :gt: is greater than
# :ge: is greater than or equal to
# :lt: is less than
# :le: is less than or equal to
# :eq: is equal
# :ne: is not equal
# %26 is an AND statement
# | is an OR statement
# :sw: is starts with
# :ew: is ends with
# :cv: is contains values
# :nv: is does not contain value
# :cb: is contained between (two dates for instance) separated by '$'
WHERE = 'coreClientFirm:eq:ExampleString'
# Replace with your desired limit of how many messages you receive. The default limit is 500
LIMIT = 500
# Order clause eg. "(field1:DESC | field1:ASC | field2:DESC:ABS | field2:ASC:ABS" (default is unordered; default is faster)
ORDER = 'locateQuan:ASC'
# Request Parameters for getmsgs Of The MsgType
params = {
# Required Parameters
"apiKey": API_KEY,
"cmd": 'getmsgs',
"msgType": MSG_TYPE,
# Optional Parameters
"view": VIEW,
"where": WHERE,
"limit": LIMIT,
"order": ORDER
}
response = requests.get(MLINK_PROD_URL, params=params)
curl -G 'https://mlink-live.nms.saturn.spiderrockconnect.com/rest/json' \
--data-urlencode 'apiKey=XXXX-XXXX-XXXX-XXXX' \
--data-urlencode 'cmd=getmsgs' \
--data-urlencode 'msgType=LocateFragment' \
--data-urlencode 'view=locateQuan|locateQuanUsed|availableLocateQuan|locateStatus|grantTimestamp|engineName|timestamp|statedQuan|stmtFloor|stmtTimestamp|legacyStmt|stmtRevision' \
--data-urlencode 'where=coreClientFirm:eq:ExampleString' \
--data-urlencode 'limit=500' \
--data-urlencode 'order=locateQuan:ASC'
Get Aggregate API Call
- Python
- cUrl
import requests
# Replace with your desired MLINK URL
MLINK_PROD_URL = 'https://mlink-live.nms.saturn.spiderrockconnect.com/rest/json'
# Replace with your MLINK API Key
API_KEY = 'XXXX-XXXX-XXXX-XXXX'
# Replace with your desired MsgType.
MSG_TYPE = 'LocateFragment'
# Replace with fields you want to see aggregate values for. A "|" separated list of measures should be provided
MEASURE = 'locateQuan|locateQuanUsed|availableLocateQuan|locateStatus|grantTimestamp|engineName|timestamp|statedQuan|stmtFloor|stmtTimestamp|legacyStmt|stmtRevision'
# Replace with fields you want to see aggregated. A "|" separated list of fields should be provided
GROUP = 'locateStatus|legacyStmt'
# Replace with your desired where clause.
# a string in the form "field1:eq:value" or "(field1:ne:value1 & field1:ne:value2)
# "WHERE" clauses can contain the following comparison symbols:
# :gt: is greater than
# :ge: is greater than or equal to
# :lt: is less than
# :le: is less than or equal to
# :eq: is equal
# :ne: is not equal
# %26 is an AND statement
# | is an OR statement
# :sw: is starts with
# :ew: is ends with
# :cv: is contains values
# :nv: is does not contain value
# :cb: is contained between (two dates for instance) separated by '$'
WHERE = 'coreClientFirm:eq:ExampleString'
# Request Parameters for getaggregate Of The MsgType
params = {
# Required Parameters
"apiKey": API_KEY,
"cmd": 'getaggregate',
"msgType": MSG_TYPE,
"measure": MEASURE,
"group": GROUP,
# Optional Parameters
"where": WHERE,
}
response = requests.get(MLINK_PROD_URL, params=params)
curl -G 'https://mlink-live.nms.saturn.spiderrockconnect.com/rest/json' \
--data-urlencode 'apiKey=XXXX-XXXX-XXXX-XXXX' \
--data-urlencode 'cmd=getaggregate' \
--data-urlencode 'msgType=LocateFragment' \
--data-urlencode 'measure=locateQuan|locateQuanUsed|availableLocateQuan|locateStatus|grantTimestamp|engineName|timestamp|statedQuan|stmtFloor|stmtTimestamp|legacyStmt|stmtRevision' \
--data-urlencode 'group=locateStatus|legacyStmt' \
--data-urlencode 'where=coreClientFirm:eq:ExampleString'
Get Count API Call
- Python
- cUrl
import requests
# Replace with your desired MLINK URL
MLINK_PROD_URL = 'https://mlink-live.nms.saturn.spiderrockconnect.com/rest/json'
# Replace with your MLINK API Key
API_KEY = 'XXXX-XXXX-XXXX-XXXX'
# Replace with your desired MsgType.
MSG_TYPE = 'LocateFragment'
# Replace with your desired where clause.
# a string in the form "field1:eq:value" or "(field1:ne:value1 & field1:ne:value2)
# "WHERE" clauses can contain the following comparison symbols:
# :gt: is greater than
# :ge: is greater than or equal to
# :lt: is less than
# :le: is less than or equal to
# :eq: is equal
# :ne: is not equal
# %26 is an AND statement
# | is an OR statement
# :sw: is starts with
# :ew: is ends with
# :cv: is contains values
# :nv: is does not contain value
# :cb: is contained between (two dates for instance) separated by '$'
WHERE = 'coreClientFirm:eq:ExampleString'
# Request Parameters for getCount Of The MsgType
params = {
# Required Parameters
"apiKey": API_KEY,
"cmd": 'getcount',
"msgType": MSG_TYPE,
# Optional Parameters
"where": WHERE,
}
response = requests.get(MLINK_PROD_URL, params=params)
curl -G 'https://mlink-live.nms.saturn.spiderrockconnect.com/rest/json' \
--data-urlencode 'apiKey=XXXX-XXXX-XXXX-XXXX' \
--data-urlencode 'cmd=getcount' \
--data-urlencode 'msgType=LocateFragment' \
--data-urlencode 'where=coreClientFirm:eq:ExampleString'